# Advent of Code 2021

The general setup of the modules was originally inspired by [José Valim's 2018 AoC Twitch stream](https://www.twitch.tv/videos/346878345),
but has since evolved in a different direction.

To get the solutions for a day XX, run `mix day XX`; this will automatically pass in the file `lib/XX/input.txt` as an argument.
To use another file, simply append its path to the command: `mix day XX path/to/file.txt`.

## Structure

The data, tests, and code for each day lives inside the `lib/XX` directory, where XX is the two-digit day number (*e.g.* 01 or 22).
Each day consists of a file `main.ex` containing a single module `AoC2021.DayXX` with three public functions:
- `setup/1`: takes a file name and returns the parsed and marshalled file contents;
- `part1/1`: takes the output from `setup/1` and returns the solution to part 1;
- `part2/1`: takes the output from `setup/1` and returns the solution to part 2.

Additionally, there is a `test.exs` file containing three sets of tests, one for each function described above.
Lastly, the actual inputs are found in each dat's `data/` directory. The day's individual input is always named `input.txt`.
The test data is named `test.txt`, except on days where there are multiple test inputs (such as day 12),
where they will usually be named according to the input size (*e.g* `small.txt` and `large.txt`).

## Testing

Tests are included for each day [as described above](#structure). To run them all use `mix test`; for a specific day run `mix test lib/XX`.
A code coverage report can be generated by running `mix test --cover`.

## Dependencies

Any dependency installed via mix (`mix deps.get`) will be available in any module without needing to be imported.

## Profiling

To profile a given day XX, run `mix profile.eprof -e "Mix.Tasks.Day.run([XX])"`.
Alternatively `mix profile.cprof` or `mix profile.fprof` can also be used for various levels of detail.
